#ifndef __G39DDCAPI_H__
#define __G39DDCAPI_H__

#ifdef WIN32_LEAN_AND_MEAN

#include <basetyps.h>

#endif

#include <windows.h>

#define G39DDC_CLASS_ID_DEVICE_ENUMERATOR  0x1001
#define G39DDC_CLASS_ID_DEVICE             0x1002

#define G39DDC_INTERFACE_TYPE_PCIE    0
#define G39DDC_INTERFACE_TYPE_USB     1


typedef BOOL (__stdcall *G39DDCAPI_CREATE_INSTANCE)(UINT32 ClassId,PVOID *Interface);

#define G39DDC_OPEN_DEMO   ((CHAR*)0x00000000)
#define G39DDC_OPEN_FIRST  ((CHAR*)0xFFFFFFFF)

#define G39DDC_FRONT_PANEL_LED_MODE_DIAG    0
#define G39DDC_FRONT_PANEL_LED_MODE_ON      1
#define G39DDC_FRONT_PANEL_LED_MODE_OFF     2

#define G39DDC_ATTENUATOR_0dB       0
#define G39DDC_ATTENUATOR_6dB       1
#define G39DDC_ATTENUATOR_12dB      2
#define G39DDC_ATTENUATOR_18dB      3
#define G39DDC_ATTENUATOR_MAX       G39DDC_ATTENUATOR_18dB

#define G39DDC_HARDWARE_OPTIONS_EXTERNAL_REFERENCE      0x00000001
#define G39DDC_HARDWARE_OPTIONS_AUDIO_OUTPUT			0x00000002
#define G39DDC_HARDWARE_OPTIONS_FCC			            0x80000000

#define G39DDC_DEVICE_STATE_TEMP_ERROR                  0x00000001
#define G39DDC_DEVICE_STATE_FAN_ERROR                   0x00000002
#define G39DDC_DEVICE_STATE_VCC_ERROR                   0x00000004
#define G39DDC_DEVICE_STATE_COMM_ERROR                  0x00000008

#define G39DDC_MODE_AM               0x00
#define G39DDC_MODE_AMS              0x01
#define G39DDC_MODE_LSB              0x02
#define G39DDC_MODE_USB              0x03
#define G39DDC_MODE_DSB              0x04
#define G39DDC_MODE_ISB              0x05
#define G39DDC_MODE_CW               0x06
#define G39DDC_MODE_FM               0x07
#define G39DDC_MODE_FMW              0x08
#define G39DDC_MODE_DRM              0x09
#define G39DDC_MODE_COUNT            (G39DDC_MODE_DRM+1)

#define G39DDC_SIDE_BAND_LOWER         0x01
#define G39DDC_SIDE_BAND_UPPER         0x02
#define G39DDC_SIDE_BAND_BOTH          (G39DDC_SIDE_BAND_LOWER|G39DDC_SIDE_BAND_UPPER)

#define G39DDC_DEMODULATOR_PARAM_AMS_SIDE_BAND          0x00000001
#define G39DDC_DEMODULATOR_PARAM_ISB_SIDE_BAND          0x00000002
#define G39DDC_DEMODULATOR_PARAM_DSB_SIDE_BAND          0x00000003
#define G39DDC_DEMODULATOR_PARAM_FMW_STEREO             0x00000004
#define G39DDC_DEMODULATOR_PARAM_CW_FREQUENCY           0x00000005
#define G39DDC_DEMODULATOR_PARAM_FMW_DEEMPHASIS         0x00000006
#define G39DDC_DEMODULATOR_PARAM_DRM_AUDIO_SERVICE      0x00000007
#define G39DDC_DEMODULATOR_PARAM_DRM_MULTIMEDIA_SERVICE 0x00000008
#define G39DDC_DEMODULATOR_PARAM_AMS_CAPTURE_RANGE      0x00000009

#define G39DDC_DEMODULATOR_STATE_AMS_LOCK               0x00000001
#define G39DDC_DEMODULATOR_STATE_AMS_FREQUENCY          0x00000002
#define G39DDC_DEMODULATOR_STATE_DSB_LOCK               0x00000003
#define G39DDC_DEMODULATOR_STATE_DSB_FREQUENCY          0x00000004
#define G39DDC_DEMODULATOR_STATE_AM_DEPTH               0x00000005
#define G39DDC_DEMODULATOR_STATE_TUNE_ERROR             0x00000006
#define G39DDC_DEMODULATOR_STATE_DRM_STATUS             0x00000007
#define G39DDC_DEMODULATOR_STATE_FMW_STEREO             0x00000008
#define G39DDC_DEMODULATOR_STATE_FM_DEVIATION           0x00000009

#define G39DDC_DRM_STATE_MODE_NOT_DETERMINED_YET       -1
#define G39DDC_DRM_STATE_MODE_A                        0
#define G39DDC_DRM_STATE_MODE_B                        1
#define G39DDC_DRM_STATE_MODE_C                        2
#define G39DDC_DRM_STATE_MODE_D                        3

#define G39DDC_DRM_STATE_INTERLEAVER_LONG              0       //long interleaver used (2 sec)
#define G39DDC_DRM_STATE_INTERLEAVER_SHORT             1       //short interleaver used (400 msec)

#define G39DDC_DRM_STATE_QAM_TYPE_STD                  0       //standard
#define G39DDC_DRM_STATE_QAM_TYPE_HIER_SYM             1       //hierarchical symmetrical
#define G39DDC_DRM_STATE_QAM_TYPE_HIER_MIX             2       //hierarchical mixed

#define G39DDC_DRM_STATE_SERVICE_CONTENT_EMPTY         0x00    //service is not used/contains no data
#define G39DDC_DRM_STATE_SERVICE_CONTENT_AUDIO         0x01    //service contains audio data
#define G39DDC_DRM_STATE_SERVICE_CONTENT_TEXTMSG       0x02    //service contains text messages
#define G39DDC_DRM_STATE_SERVICE_CONTENT_MULTIMEDIA    0x04    //service contains multimedia data
#define G39DDC_DRM_STATE_SERVICE_CONTENT_DATA          0x08    //service contains application specific data

#define G39DDC_DRM_STATE_AUDIO_CODING_AAC              0       //audio coding is AAC
#define G39DDC_DRM_STATE_AUDIO_CODING_CELP             1       //audio coding is CELP
#define G39DDC_DRM_STATE_AUDIO_CODING_HVXC             2       //audio coding is HVXC
#define G39DDC_DRM_STATE_AUDIO_CODING_RFU              3       //reserved for future use

#define G39DDC_DRM_STATE_AUDIO_MODE_AAC_MONO           0       //mono
#define G39DDC_DRM_STATE_AUDIO_MODE_AAC_PARAM_STEREO   1       //parametric stereo
#define G39DDC_DRM_STATE_AUDIO_MODE_AAC_STEREO         2       //stereo
#define G39DDC_DRM_STATE_AUDIO_MODE_AAC_RFU            3       //reserved for future use
	
#define G39DDC_DRM_STATE_AUDIO_MODE_CELP_NO_CRC        0       //audio data is without CRC
#define G39DDC_DRM_STATE_AUDIO_MODE_CELP_CRC           1       //CRC used
#define G39DDC_DRM_STATE_AUDIO_MODE_CELP_RFU_10        2       //reserved for future use
#define G39DDC_DRM_STATE_AUDIO_MODE_CELP_RFU_11        3       //reserved for future use
	
#define G39DDC_DRM_STATE_AUDIO_MODE_HVXC_RFU_00        0       //reserved for future use
#define G39DDC_DRM_STATE_AUDIO_MODE_HVXC_RFU_01        1       //reserved for future use
#define G39DDC_DRM_STATE_AUDIO_MODE_HVXC_RFU_10        2       //reserved for future use
#define G39DDC_DRM_STATE_AUDIO_MODE_HVXC_RFU_11        3       //reserved for future use


#define G39DDC_FLUSH_BUFFERS_IF                        0x0001
#define G39DDC_FLUSH_BUFFERS_DDC1                      0x0002
#define G39DDC_FLUSH_BUFFERS_DDC2                      0x0004
#define G39DDC_FLUSH_BUFFERS_AUDIO                     0x0008

#pragma pack(push,1)

typedef struct
{
    UINT32  Tune;   //Hz
    UINT32  Lock;   //Hz
} G39DDC_AMS_CAPTURE_RANGE;

typedef struct
{
    BOOL            Valid;                          //entries below are invalid/valid

    struct
    {
        BOOL        SyncFound;
        BOOL        FACDecoded;
        BOOL        SDCDecoded;
        BOOL        AudioDecoded;
        SHORT       NumberOfAudioFrames;            //-1 if not available
        SHORT       NumberOfAudioErrors;            //-1 if not available	
    } DecodingState;


    INT32           Mode;                           //DRM_STATE_MODE_*
	double          RFBandwidth;                    //occupied RF bandwith in kHz, 0 = invalid or information not (yet) available
    BYTE            Interleaver;                    //DRM_STATE_INTERLEAVER_*
    SHORT           SDCQam;                         //coding of the SDC (QAM), 0 = not (yet) available
    SHORT           MSCQam;                         //coding of the MSC (QAM), 0 = not (yet) available
    BYTE            MSCQamType;                     //DRM_STATE_QAM_TYPE_* , used QAM coding for the MSC
    double          CoderateH;				        //used coderate for hierachical coding,  values <= 0 indicate not available or not used
    double          CoderateA;				        //used coderate for protection level A,  values <= 0 indicate not available or not used
    double          CoderateB;				        //used coderate for protection level B,  values <= 0 indicate not available or not used
    double          EstimatedSNR;			        //estimated SNR in dB of the decoded signal
    wchar_t         TextMessage[128 + 1 + 16];      //text message containing max. 128 byte text + string termination + max. 16 linebreaks
   
    struct
    {
        BYTE        Content;				        //DRM_STATE_SERVICE_CONTRENT_*
        wchar_t     DynamicLabel[256];		        //string containing dynamic label of the service, zero terminated
        wchar_t     Country[256];			        //string containing the signaled country for this service
        wchar_t     Language[256];			        //string containing the signaled language for this service
        wchar_t     ProgramType[256];		        //string containing the signaled program type for this service
        double      AudioBitrate;			        //data rate for the audio content (0 if not available)
        double      TextMsgBitrate;			        //data rate for the text message content (0 if not available)
        double      MultimediaBitrate;		        //data rate for the multimedia content (0 if not available)
        double      DataBitrate;			        //data rate for the data content (0 if not available)
    } ServiceInfo[4];

    struct
    {
        BOOL        Valid;                          //audio decoder information valid/invalid, when invalid all other entries of the struct contain no valid data
        BYTE        AudioCoding;                    //DRM_STATE_AUDIO_CODING_*        
        BOOL        SBR;                            //SBR used/not used (TRUE/FALSE)
        INT32       AudioMode;                      //depeding on the audio coding, DRM_STATE_AUDIO_MODE_*
    } AudioDecoderInfo[4];
} G39DDC_DRM_STATUS;


typedef struct
{
    char        DevicePath[MAX_PATH];
    BYTE        InterfaceType;
    char        SerialNumber[9];
    WORD        HWVersion;
    WORD        FWVersion;
    BYTE        EEPROMVersion;
    UINT32      ChannelCount;
    UINT64      FrontEndMinFrequency;
    UINT64      FrontEndMaxFrequency;
    UINT64      FrontEndMaxHFFrequency;
    UINT32      FrontEndFrequencyStep;
    UINT32      FrontEndWindowWidth;
    UINT32      HardwareOptions;
} G39DDC_DEVICE_INFO;

typedef struct
{
    UINT32      SampleRate;
    UINT32      Bandwidth;
    UINT32      BitsPerSample;
} G39DDC_DDC_INFO;


#undef INTERFACE
#define INTERFACE IG39DDCDeviceEnumerator

DECLARE_INTERFACE(IG39DDCDeviceEnumerator)
{
    STDMETHOD_(LONG,AddRef)(THIS) PURE;
    STDMETHOD_(LONG,Release)(THIS) PURE;

    STDMETHOD_(BOOL,Enumerate)(THIS) PURE;
    STDMETHOD_(UINT32,GetCount)(THIS) PURE;
    STDMETHOD_(BOOL,GetDeviceInfo)(THIS_ UINT32 DeviceIndex,G39DDC_DEVICE_INFO *DeviceInfo,UINT32 BufferLength) PURE;
};

#undef INTERFACE
#define INTERFACE IG39DDCDeviceCallback

struct IG39DDCDevice;

DECLARE_INTERFACE(IG39DDCDeviceCallback)
{    
    STDMETHOD_(VOID,G39DDC_DDC1StreamCallback)(THIS_ struct IG39DDCDevice *Device,UINT32 Channel,CONST VOID *Buffer,UINT32 NumberOfSamples,UINT32 BitsPerSample) PURE;
    STDMETHOD_(BOOL,G39DDC_DDC1PlaybackStreamCallback)(THIS_ struct IG39DDCDevice *Device,UINT32 Channel,VOID *Buffer,UINT32 NumberOfSamples,UINT32 BitsPerSample) PURE;
    STDMETHOD_(VOID,G39DDC_DDC2StreamCallback)(THIS_ struct IG39DDCDevice *Device,UINT32 Channel,CONST float *Buffer,UINT32 NumberOfSamples) PURE;        
    STDMETHOD_(VOID,G39DDC_DDC2PreprocessedStreamCallback)(THIS_ struct IG39DDCDevice *Device,UINT32 Channel,CONST float *Buffer,UINT32 NumberOfSamples,float SlevelPeak,float SlevelRMS) PURE;
    STDMETHOD_(VOID,G39DDC_IFCallback)(THIS_ struct IG39DDCDevice *Device,CONST SHORT *Buffer,UINT32 NumberOfSamples,UINT32 CenterFrequency,WORD MaxADCAmplitude,UINT32 ADCSampleRate) PURE;
    STDMETHOD_(BOOL,G39DDC_SweepingCallback)(THIS_ struct IG39DDCDevice *Device,CONST SHORT *Buffer,UINT32 NumberOfSamples,UINT32 CenterFrequency,UINT64 FrontEndFrequency) PURE;
    STDMETHOD_(VOID,G39DDC_AudioStreamCallback)(THIS_ struct IG39DDCDevice *Device,UINT32 Channel,UINT32 Type,CONST float *Buffer,UINT32 NumberOfSamples) PURE;
    STDMETHOD_(BOOL,G39DDC_AudioPlaybackStreamCallback)(THIS_ struct IG39DDCDevice *Device,UINT32 Channel,float *Buffer,UINT32 NumberOfSamples) PURE;
};

#undef INTERFACE
#define INTERFACE IG39DDCDevice


DECLARE_INTERFACE(IG39DDCDevice)
{
    STDMETHOD_(LONG,AddRef)(THIS) PURE;
    STDMETHOD_(LONG,Release)(THIS) PURE;

    STDMETHOD_(BOOL,Open)(THIS_ CONST CHAR *DevicePath) PURE;
    STDMETHOD_(VOID,Close)(THIS) PURE;

    STDMETHOD_(BOOL,IsConnected)(THIS) PURE;

    STDMETHOD_(VOID,SetCallback)(THIS_ IG39DDCDeviceCallback *Callback) PURE;
    STDMETHOD_(IG39DDCDeviceCallback*,GetCallback)(THIS) PURE;

    STDMETHOD_(BOOL,GetDeviceInfo)(THIS_ G39DDC_DEVICE_INFO *Info,UINT32 BufferLength) PURE;

    STDMETHOD_(BOOL,SetLED)(THIS_ UINT32 LEDMode) PURE;
    STDMETHOD_(BOOL,GetLED)(THIS_ UINT32 *LEDMode) PURE;

    STDMETHOD_(BOOL,SetPower)(THIS_ BOOL Power) PURE;
    STDMETHOD_(BOOL,GetPower)(THIS_ BOOL *Power) PURE;

    STDMETHOD_(BOOL,SetExternalReference)(THIS_ BOOL Enabled) PURE;
    STDMETHOD_(BOOL,GetExternalReference)(THIS_ BOOL *Enabled) PURE;

    STDMETHOD_(BOOL,SetFrontEndFrequency)(THIS_ UINT64 Frequency) PURE;
    STDMETHOD_(BOOL,GetFrontEndFrequency)(THIS_ UINT64 *Frequency) PURE;    

    STDMETHOD_(BOOL,SetAttenuator)(THIS_ UINT32 Attenuator) PURE;
    STDMETHOD_(BOOL,GetAttenuator)(THIS_ UINT32 *Attenuator) PURE;
    STDMETHOD_(BOOL,SetPreamplifier)(THIS_ BOOL Preamp) PURE;
    STDMETHOD_(BOOL,GetPreamplifier)(THIS_ BOOL *Preamp) PURE;

    STDMETHOD_(BOOL,SetDithering)(THIS_ BOOL Dithering) PURE;
    STDMETHOD_(BOOL,GetDithering)(THIS_ BOOL *Dithering) PURE;

    STDMETHOD_(BOOL,SetADCNoiseBlanker)(THIS_ BOOL Enabled) PURE;
    STDMETHOD_(BOOL,GetADCNoiseBlanker)(THIS_ BOOL *Enabled) PURE;
    STDMETHOD_(BOOL,SetADCNoiseBlankerThreshold)(THIS_ WORD Threshold) PURE;
    STDMETHOD_(BOOL,GetADCNoiseBlankerThreshold)(THIS_ WORD *Threshold) PURE;

    STDMETHOD_(BOOL,SetFrequency)(THIS_ UINT32 Channel,UINT64 Frequency) PURE;
    STDMETHOD_(BOOL,GetFrequency)(THIS_ UINT32 Channel,UINT64 *Frequency) PURE;

    STDMETHOD_(BOOL,StartIF)(THIS_ WORD Period) PURE;
    STDMETHOD_(BOOL,StopIF)(THIS) PURE;

    STDMETHOD_(BOOL,GetDDCInfo)(THIS_ UINT32 DDCIndex,G39DDC_DDC_INFO *Info) PURE;

    STDMETHOD_(BOOL,GetDDC1Count)(THIS_ UINT32 Channel,UINT32 *Count) PURE;
    STDMETHOD_(BOOL,SetDDC1)(THIS_ UINT32 Channel,UINT32 DDCIndex) PURE;
    STDMETHOD_(BOOL,GetDDC1)(THIS_ UINT32 Channel,UINT32 *DDCIndex) PURE;
    STDMETHOD_(BOOL,StartDDC1)(THIS_ UINT32 Channel,UINT32 SamplesPerBuffer) PURE;
    STDMETHOD_(BOOL,StopDDC1)(THIS_ UINT32 Channel) PURE;
    STDMETHOD_(BOOL,SetDDC1Frequency)(THIS_ UINT32 Channel,INT32 Frequency) PURE;
    STDMETHOD_(BOOL,GetDDC1Frequency)(THIS_ UINT32 Channel,INT32 *Frequency) PURE;
    STDMETHOD_(BOOL,StartDDC1Playback)(THIS_ UINT32 Channel,UINT32 SamplesPerBuffer,UINT32 BitsPerSample) PURE;
    STDMETHOD_(BOOL,PauseDDC1Playback)(THIS_ UINT32 Channel) PURE;
    STDMETHOD_(BOOL,ResumeDDC1Playback)(THIS_ UINT32 Channel) PURE;

    STDMETHOD_(BOOL,GetDDC2Count)(THIS_ UINT32 Channel,UINT32 *Count) PURE;
    STDMETHOD_(BOOL,SetDDC2)(THIS_ UINT32 Channel,UINT32 DDCIndex) PURE;
    STDMETHOD_(BOOL,GetDDC2)(THIS_ UINT32 Channel,UINT32 *DDCIndex) PURE;
    STDMETHOD_(BOOL,StartDDC2)(THIS_ UINT32 Channel,UINT32 SamplesPerBuffer) PURE;
    STDMETHOD_(BOOL,StopDDC2)(THIS_ UINT32 Channel) PURE;
    STDMETHOD_(BOOL,SetDDC2Frequency)(THIS_ UINT32 Channel,INT32 Frequency) PURE;
    STDMETHOD_(BOOL,GetDDC2Frequency)(THIS_ UINT32 Channel,INT32 *Frequency) PURE;

    STDMETHOD_(BOOL,SetAGC)(THIS_ UINT32 Channel,BOOL Enabled) PURE;
    STDMETHOD_(BOOL,GetAGC)(THIS_ UINT32 Channel,BOOL *Enabled) PURE;
    STDMETHOD_(BOOL,SetAGCParams)(THIS_ UINT32 Channel,double AttackTime,double DecayTime,double ReferenceLevel) PURE;
    STDMETHOD_(BOOL,GetAGCParams)(THIS_ UINT32 Channel,double *AttackTime,double *DecayTime,double *ReferenceLevel) PURE;
    STDMETHOD_(BOOL,SetMaxAGCGain)(THIS_ UINT32 Channel,double MaxGain) PURE;
    STDMETHOD_(BOOL,GetMaxAGCGain)(THIS_ UINT32 Channel,double *MaxGain) PURE;
    STDMETHOD_(BOOL,SetGain)(THIS_ UINT32 Channel,double Gain) PURE;
    STDMETHOD_(BOOL,GetGain)(THIS_ UINT32 Channel,double *Gain) PURE;
    STDMETHOD_(BOOL,GetCurrentGain)(THIS_ UINT32 Channel,double *Gain) PURE;

    STDMETHOD_(BOOL,SetNotchFilter)(THIS_ UINT32 Channel,UINT32 FilterIndex,BOOL Enabled) PURE;
    STDMETHOD_(BOOL,GetNotchFilter)(THIS_ UINT32 Channel,UINT32 FilterIndex,BOOL *Enabled) PURE;
    STDMETHOD_(BOOL,SetNotchFilterFrequency)(THIS_ UINT32 Channel,UINT32 FilterIndex,INT32 Frequency) PURE;
    STDMETHOD_(BOOL,GetNotchFilterFrequency)(THIS_ UINT32 Channel,UINT32 FilterIndex,INT32 *Frequency) PURE;
    STDMETHOD_(BOOL,SetNotchFilterBandwidth)(THIS_ UINT32 Channel,UINT32 FilterIndex,UINT32 Bandwidth) PURE;
    STDMETHOD_(BOOL,GetNotchFilterBandwidth)(THIS_ UINT32 Channel,UINT32 FilterIndex,UINT32 *Bandwidth) PURE;
    STDMETHOD_(BOOL,SetNotchFilterLength)(THIS_ UINT32 Channel,UINT32 FilterIndex,UINT32 Length) PURE;
    STDMETHOD_(BOOL,GetNotchFilterLength)(THIS_ UINT32 Channel,UINT32 FilterIndex,UINT32 *Length) PURE;

    STDMETHOD_(BOOL,SetDemodulatorFrequency)(THIS_ UINT32 Channel,INT32 Frequency) PURE;
    STDMETHOD_(BOOL,GetDemodulatorFrequency)(THIS_ UINT32 Channel,INT32 *Frequency) PURE;
    STDMETHOD_(BOOL,SetDemodulatorFilterBandwidth)(THIS_ UINT32 Channel,UINT32 Bandwidth) PURE;
    STDMETHOD_(BOOL,GetDemodulatorFilterBandwidth)(THIS_ UINT32 Channel,UINT32 *Bandwidth) PURE;
    STDMETHOD_(BOOL,SetDemodulatorFilterShift)(THIS_ UINT32 Channel,INT32 Shift) PURE;
    STDMETHOD_(BOOL,GetDemodulatorFilterShift)(THIS_ UINT32 Channel,INT32 *Shift) PURE;
    STDMETHOD_(BOOL,SetDemodulatorFilterLength)(THIS_ UINT32 Channel,UINT32 Length) PURE;
    STDMETHOD_(BOOL,GetDemodulatorFilterLength)(THIS_ UINT32 Channel,UINT32 *Length) PURE;
    STDMETHOD_(BOOL,SetDemodulatorMode)(THIS_ UINT32 Channel,UINT32 Mode) PURE;
    STDMETHOD_(BOOL,GetDemodulatorMode)(THIS_ UINT32 Channel,UINT32 *Mode) PURE;
    STDMETHOD_(BOOL,SetDemodulatorParam)(THIS_ UINT32 Channel,UINT32 Code,CONST VOID *Buffer,UINT32 BufferSize) PURE;
    STDMETHOD_(BOOL,GetDemodulatorParam)(THIS_ UINT32 Channel,UINT32 Code,VOID *Buffer,UINT32 BufferSize) PURE;
    STDMETHOD_(BOOL,GetDemodulatorState)(THIS_ UINT32 Channel,UINT32 Code,VOID *Buffer,UINT32 BufferSize) PURE;  
    
    STDMETHOD_(BOOL,SetDRMKey)(THIS_ CONST CHAR *DRMKeyFileDirectory) PURE;
    STDMETHOD_(BOOL,IsDRMUnlocked)(THIS) PURE;

    STDMETHOD_(BOOL,GetAudioSampleRateCount)(THIS_ UINT32 *Count) PURE;
    STDMETHOD_(BOOL,GetAudioSampleRate)(THIS_ UINT32 SampleRateIndex,UINT32 *SampleRate) PURE;
    STDMETHOD_(BOOL,StartAudio)(THIS_ UINT32 Channel,UINT32 SamplesPerBuffer) PURE;
    STDMETHOD_(BOOL,StopAudio)(THIS_ UINT32 Channel) PURE;
    STDMETHOD_(BOOL,SetAudio)(THIS_ UINT32 Channel,UINT32 SampleRateIndex) PURE;
    STDMETHOD_(BOOL,GetAudio)(THIS_ UINT32 Channel,UINT32 *SampleRateIndex) PURE;
    STDMETHOD_(BOOL,StartAudioPlayback)(THIS_ UINT32 Channel,UINT32 SamplesPerBuffer) PURE;
    STDMETHOD_(BOOL,PauseAudioPlayback)(THIS_ UINT32 Channel) PURE;
    STDMETHOD_(BOOL,ResumeAudioPlayback)(THIS_ UINT32 Channel) PURE;
    STDMETHOD_(BOOL,SetAudioFilter)(THIS_ UINT32 Channel,BOOL Enabled) PURE;
    STDMETHOD_(BOOL,GetAudioFilter)(THIS_ UINT32 Channel,BOOL *Enabled) PURE;
    STDMETHOD_(BOOL,SetAudioFilterParams)(THIS_ UINT32 Channel,UINT32 CutOffLow,UINT32 CutOffHigh,double Deemphasis) PURE;    
    STDMETHOD_(BOOL,GetAudioFilterParams)(THIS_ UINT32 Channel,UINT32 *CutOffLow,UINT32 *CutOffHigh,double *Deemphasis) PURE;    
    STDMETHOD_(BOOL,SetAudioFilterLength)(THIS_ UINT32 Channel,UINT32 Length) PURE;
    STDMETHOD_(BOOL,GetAudioFilterLength)(THIS_ UINT32 Channel,UINT32 *Length) PURE;
    STDMETHOD_(BOOL,SetAudioGain)(THIS_ UINT32 Channel,double Gain) PURE;
    STDMETHOD_(BOOL,GetAudioGain)(THIS_ UINT32 Channel,double *Gain) PURE;    
    STDMETHOD_(BOOL,SetVolume)(THIS_ UINT32 Channel,BYTE Volume) PURE;
    STDMETHOD_(BOOL,GetVolume)(THIS_ UINT32 Channel,BYTE *Volume) PURE;    
    STDMETHOD_(BOOL,SetMute)(THIS_ UINT32 Channel,BOOL Mute) PURE;
    STDMETHOD_(BOOL,GetMute)(THIS_ UINT32 Channel,BOOL *Mute) PURE;

    STDMETHOD_(BOOL,StartSweeping)(THIS_ UINT64 BeginFrequency,UINT64 EndFrequency,UINT64 StartFrequency,WORD SettlingTime,BOOL Forward) PURE;
    STDMETHOD_(BOOL,StopSweeping)(THIS) PURE;

    STDMETHOD_(BOOL,GetSpectrumCompensation)(THIS_ UINT64 FrontEndFrequency,INT32 Shift,UINT32 Bandwidth,float *Buffer,UINT32 Count) PURE;
    STDMETHOD_(BOOL,GetIFSpectrumCompensation)(THIS_ UINT64 FrontEndFrequency,float *Buffer,UINT32 Count) PURE;

    STDMETHOD_(BOOL,SetDAC)(THIS_ UINT32 DAC) PURE;
    STDMETHOD_(BOOL,GetDAC)(THIS_ UINT32 *DAC) PURE;

    STDMETHOD_(BOOL,FlushBuffers)(THIS_ UINT32 Channel,UINT32 Flags) PURE;
    
    STDMETHOD_(BOOL,GetTemperature)(THIS_ UINT32 *Temperature) PURE;

    STDMETHOD_(BOOL,SetInverted)(THIS_ BOOL Inverted) PURE;
    STDMETHOD_(BOOL,GetInverted)(THIS_ BOOL *Inverted) PURE;

    STDMETHOD_(BOOL,SetDDC2NoiseBlanker)(THIS_ UINT32 Channel,BOOL Enabled) PURE;
    STDMETHOD_(BOOL,GetDDC2NoiseBlanker)(THIS_ UINT32 Channel,BOOL *Enabled) PURE;
    STDMETHOD_(BOOL,SetDDC2NoiseBlankerThreshold)(THIS_ UINT32 Channel,double Threshold) PURE;
    STDMETHOD_(BOOL,GetDDC2NoiseBlankerThreshold)(THIS_ UINT32 Channel,double *Threshold) PURE;
    STDMETHOD_(BOOL,GetDDC2NoiseBlankerExcessValue)(THIS_ UINT32 Channel,double *Value) PURE;

    STDMETHOD_(BOOL,GetDeviceState)(THIS_ UINT32 *State) PURE;

    STDMETHOD_(BOOL,GetSignalLevel)(THIS_ UINT32 Channel,FLOAT *Peak,FLOAT *RMS) PURE;
};

#pragma pack(pop)

//non-object interface function declaration

typedef VOID (__stdcall *G39DDC_DDC1_STREAM_CALLBACK)(UINT32 Channel,CONST VOID *Buffer,UINT32 NumberOfSamples,UINT32 BitsPerSample,DWORD_PTR UserData);
typedef BOOL (__stdcall *G39DDC_DDC1_PLAYBACK_STREAM_CALLBACK)(UINT32 Channel,VOID *Buffer,UINT32 NumberOfSamples,UINT32 BitsPerSample,DWORD_PTR UserData);
typedef VOID (__stdcall *G39DDC_DDC2_STREAM_CALLBACK)(UINT32 Channel,CONST float *Buffer,UINT32 NumberOfSamples,DWORD_PTR UserData);
typedef VOID (__stdcall *G39DDC_DDC2_PREPROCESSED_STREAM_CALLBACK)(UINT32 Channel,CONST float *Buffer,UINT32 NumberOfSamples,float SlevelPeak,float SlevelRMS,DWORD_PTR UserData);
typedef VOID (__stdcall *G39DDC_IF_CALLBACK)(CONST SHORT *Buffer,UINT32 NumberOfSamples,UINT32 CenterFrequency,WORD Amplitude,UINT32 ADCSampleRate,DWORD_PTR UserData);
typedef BOOL (__stdcall *G39DDC_SWEEPING_CALLBACK)(CONST SHORT *Buffer,UINT32 NumberOfSamples,UINT32 CenterFrequency,UINT64 Frequency,DWORD_PTR UserData);
typedef VOID (__stdcall *G39DDC_AUDIO_STREAM_CALLBACK)(UINT32 Channel,UINT32 Type,CONST float *Buffer,UINT32 NumberOfSamples,DWORD_PTR UserData);
typedef BOOL (__stdcall *G39DDC_AUDIO_PLAYBACK_STREAM_CALLBACK)(UINT32 Channel,float *Buffer,UINT32 NumberOfSamples,DWORD_PTR UserData);

#pragma pack(push,1)

typedef struct
{
    G39DDC_IF_CALLBACK                          IFCallback;
    G39DDC_DDC1_STREAM_CALLBACK                 DDC1StreamCallback;
    G39DDC_DDC1_PLAYBACK_STREAM_CALLBACK        DDC1PlaybackStreamCallback;
    G39DDC_DDC2_STREAM_CALLBACK                 DDC2StreamCallback;
    G39DDC_DDC2_PREPROCESSED_STREAM_CALLBACK    DDC2PreprocessedStreamCallback;
    G39DDC_AUDIO_STREAM_CALLBACK                AudioStreamCallback;
    G39DDC_AUDIO_PLAYBACK_STREAM_CALLBACK       AudioPlaybackStreamCallback;
    G39DDC_SWEEPING_CALLBACK                    SweepingCallback;
} G39DDC_CALLBACKS;

#pragma pack(pop)

typedef BOOL (__stdcall *G39DDC_GET_DEVICE_LIST)(G39DDC_DEVICE_INFO *DeviceList,UINT32 BufferSize,UINT32 *Count,UINT32 *DeviceListItemSize);
typedef INT32 (__stdcall *G39DDC_OPEN_DEVICE)(const char *SerialNumber);
typedef BOOL (__stdcall *G39DDC_CLOSE_DEVICE)(INT32 hDevice);
typedef BOOL (__stdcall *G39DDC_IS_DEVICE_CONNECTED)(INT32 hDevice);
typedef BOOL (__stdcall *G39DDC_GET_DEVICE_INFO)(INT32 hDevice,G39DDC_DEVICE_INFO *Info,UINT32 BufferLength);
typedef BOOL (__stdcall *G39DDC_SET_LED)(INT32 hDevice,UINT32 LEDMode);
typedef BOOL (__stdcall *G39DDC_GET_LED)(INT32 hDevice,UINT32 *LEDMode);
typedef BOOL (__stdcall *G39DDC_SET_POWER)(INT32 hDevice,BOOL Power);
typedef BOOL (__stdcall *G39DDC_GET_POWER)(INT32 hDevice,BOOL *Power);
typedef BOOL (__stdcall *G39DDC_SET_EXTERNAL_REFERENCE)(INT32 hDevice,BOOL Enabled);
typedef BOOL (__stdcall *G39DDC_GET_EXTERNAL_REFERENCE)(INT32 hDevice,BOOL *Enabled);
typedef BOOL (__stdcall *G39DDC_SET_FRONT_END_FREQUENCY)(INT32 hDevice,UINT64 Frequency);
typedef BOOL (__stdcall *G39DDC_GET_FRONT_END_FREQUENCY)(INT32 hDevice,UINT64 *Frequency);
typedef BOOL (__stdcall *G39DDC_SET_ATTENUATOR)(INT32 hDevice,UINT32 Attenuator);
typedef BOOL (__stdcall *G39DDC_GET_ATTENUATOR)(INT32 hDevice,UINT32 *Attenuator);
typedef BOOL (__stdcall *G39DDC_SET_PREAMPLIFIER)(INT32 hDevice,BOOL Preamp);
typedef BOOL (__stdcall *G39DDC_GET_PREAMPLIFIER)(INT32 hDevice,BOOL *Preamp);
typedef BOOL (__stdcall *G39DDC_SET_DITHERING)(INT32 hDevice,BOOL Dithering);
typedef BOOL (__stdcall *G39DDC_GET_DITHERING)(INT32 hDevice,BOOL *Dithering);
typedef BOOL (__stdcall *G39DDC_SET_ADC_NOISE_BLANKER)(INT32 hDevice,BOOL Enabled);
typedef BOOL (__stdcall *G39DDC_GET_ADC_NOISE_BLANKER)(INT32 hDevice,BOOL *Enabled);
typedef BOOL (__stdcall *G39DDC_SET_ADC_NOISE_BLANKER_THRESHOLD)(INT32 hDevice,WORD Threshold);
typedef BOOL (__stdcall *G39DDC_GET_ADC_NOISE_BLANKER_THRESHOLD)(INT32 hDevice,WORD *Threshold);
typedef BOOL (__stdcall *G39DDC_SET_FREQUENCY)(INT32 hDevice,UINT32 Channel,UINT64 Frequency);
typedef BOOL (__stdcall *G39DDC_GET_FREQUENCY)(INT32 hDevice,UINT32 Channel,UINT64 *Frequency);
typedef BOOL (__stdcall *G39DDC_START_IF)(INT32 hDevice,WORD Period);
typedef BOOL (__stdcall *G39DDC_STOP_IF)(INT32 hDevice);
typedef BOOL (__stdcall *G39DDC_GET_DDC_INFO)(UINT32 DDCIndex,G39DDC_DDC_INFO *Info);
typedef BOOL (__stdcall *G39DDC_GET_DDC1_COUNT)(INT32 hDevice,UINT32 Channel,UINT32 *Count);
typedef BOOL (__stdcall *G39DDC_SET_DDC1)(INT32 hDevice,UINT32 Channel,UINT32 DDCIndex);
typedef BOOL (__stdcall *G39DDC_GET_DDC1)(INT32 hDevice,UINT32 Channel,UINT32 *DDCIndex);
typedef BOOL (__stdcall *G39DDC_START_DDC1)(INT32 hDevice,UINT32 Channel,UINT32 SamplesPerBuffer);
typedef BOOL (__stdcall *G39DDC_STOP_DDC1)(INT32 hDevice,UINT32 Channel);
typedef BOOL (__stdcall *G39DDC_SET_DDC1_FREQUENCY)(INT32 hDevice,UINT32 Channel,INT32 Frequency);
typedef BOOL (__stdcall *G39DDC_GET_DDC1_FREQUENCY)(INT32 hDevice,UINT32 Channel,INT32 *Frequency);
typedef BOOL (__stdcall *G39DDC_START_DDC1_PLAYBACK)(INT32 hDevice,UINT32 Channel,UINT32 SamplesPerBuffer,UINT32 BitsPerSample);
typedef BOOL (__stdcall *G39DDC_PAUSE_DDC1_PLAYBACK)(INT32 hDevice,UINT32 Channel);
typedef BOOL (__stdcall *G39DDC_RESUME_DDC1_PLAYBACK)(INT32 hDevice,UINT32 Channel);
typedef BOOL (__stdcall *G39DDC_GET_DDC2_COUNT)(INT32 hDevice,UINT32 Channel,UINT32 *Count);
typedef BOOL (__stdcall *G39DDC_SET_DDC2)(INT32 hDevice,UINT32 Channel,UINT32 DDCIndex);
typedef BOOL (__stdcall *G39DDC_GET_DDC2)(INT32 hDevice,UINT32 Channel,UINT32 *DDCIndex);
typedef BOOL (__stdcall *G39DDC_START_DDC2)(INT32 hDevice,UINT32 Channel,UINT32 SamplesPerBuffer);
typedef BOOL (__stdcall *G39DDC_STOP_DDC2)(INT32 hDevice,UINT32 Channel);
typedef BOOL (__stdcall *G39DDC_SET_DDC2_FREQUENCY)(INT32 hDevice,UINT32 Channel,INT32 Frequency);
typedef BOOL (__stdcall *G39DDC_GET_DDC2_FREQUENCY)(INT32 hDevice,UINT32 Channel,INT32 *Frequency);
typedef BOOL (__stdcall *G39DDC_GET_SIGNAL_LEVEL)(INT32 hDevice,UINT32 Channel,FLOAT *Peak,FLOAT *RMS);
typedef BOOL (__stdcall *G39DDC_SET_AGC)(INT32 hDevice,UINT32 Channel,BOOL Enabled);
typedef BOOL (__stdcall *G39DDC_GET_AGC)(INT32 hDevice,UINT32 Channel,BOOL *Enabled);
typedef BOOL (__stdcall *G39DDC_SET_AGC_PARAMS)(INT32 hDevice,UINT32 Channel,double AttackTime,double DecayTime,double ReferenceLevel);
typedef BOOL (__stdcall *G39DDC_GET_AGC_PARAMS)(INT32 hDevice,UINT32 Channel,double *AttackTime,double *DecayTime,double *ReferenceLevel);
typedef BOOL (__stdcall *G39DDC_SET_MAX_AGC_GAIN)(INT32 hDevice,UINT32 Channel,double MaxGain);
typedef BOOL (__stdcall *G39DDC_GET_MAX_AGC_GAIN)(INT32 hDevice,UINT32 Channel,double *MaxGain);
typedef BOOL (__stdcall *G39DDC_SET_GAIN)(INT32 hDevice,UINT32 Channel,double Gain);
typedef BOOL (__stdcall *G39DDC_GET_GAIN)(INT32 hDevice,UINT32 Channel,double *Gain);
typedef BOOL (__stdcall *G39DDC_GET_CURRENT_GAIN)(INT32 hDevice,UINT32 Channel,double *Gain);
typedef BOOL (__stdcall *G39DDC_SET_NOTCH_FILTER)(INT32 hDevice,UINT32 Channel,UINT32 FilterIndex,BOOL Enabled);
typedef BOOL (__stdcall *G39DDC_GET_NOTCH_FILTER)(INT32 hDevice,UINT32 Channel,UINT32 FilterIndex,BOOL *Enabled);
typedef BOOL (__stdcall *G39DDC_SET_NOTCH_FILTER_FREQUENCY)(INT32 hDevice,UINT32 Channel,UINT32 FilterIndex,INT32 Frequency);
typedef BOOL (__stdcall *G39DDC_GET_NOTCH_FILTER_FREQUENCY)(INT32 hDevice,UINT32 Channel,UINT32 FilterIndex,INT32 *Frequency);
typedef BOOL (__stdcall *G39DDC_SET_NOTCH_FILTER_BANDWIDTH)(INT32 hDevice,UINT32 Channel,UINT32 FilterIndex,UINT32 Bandwidth);
typedef BOOL (__stdcall *G39DDC_GET_NOTCH_FILTER_BANDWIDTH)(INT32 hDevice,UINT32 Channel,UINT32 FilterIndex,UINT32 *Bandwidth);
typedef BOOL (__stdcall *G39DDC_SET_NOTCH_FILTER_LENGTH)(INT32 hDevice,UINT32 Channel,UINT32 FilterIndex,UINT32 Length);
typedef BOOL (__stdcall *G39DDC_GET_NOTCH_FILTER_LENGTH)(INT32 hDevice,UINT32 Channel,UINT32 FilterIndex,UINT32 *Length);
typedef BOOL (__stdcall *G39DDC_SET_DEMODULATOR_FREQUENCY)(INT32 hDevice,UINT32 Channel,INT32 Frequency);
typedef BOOL (__stdcall *G39DDC_GET_DEMODULATOR_FREQUENCY)(INT32 hDevice,UINT32 Channel,INT32 *Frequency);
typedef BOOL (__stdcall *G39DDC_SET_DEMODULATOR_FILTER_BANDWIDTH)(INT32 hDevice,UINT32 Channel,UINT32 Bandwidth);
typedef BOOL (__stdcall *G39DDC_GET_DEMODULATOR_FILTER_BANDWIDTH)(INT32 hDevice,UINT32 Channel,UINT32 *Bandwidth);
typedef BOOL (__stdcall *G39DDC_SET_DEMODULATOR_FILTER_SHIFT)(INT32 hDevice,UINT32 Channel,INT32 Shift);
typedef BOOL (__stdcall *G39DDC_GET_DEMODULATOR_FILTER_SHIFT)(INT32 hDevice,UINT32 Channel,INT32 *Shift);
typedef BOOL (__stdcall *G39DDC_SET_DEMODULATOR_FILTER_LENGTH)(INT32 hDevice,UINT32 Channel,UINT32 Length);
typedef BOOL (__stdcall *G39DDC_GET_DEMODULATOR_FILTER_LENGTH)(INT32 hDevice,UINT32 Channel,UINT32 *Length);
typedef BOOL (__stdcall *G39DDC_SET_DEMODULATOR_MODE)(INT32 hDevice,UINT32 Channel,UINT32 Mode);
typedef BOOL (__stdcall *G39DDC_GET_DEMODULATOR_MODE)(INT32 hDevice,UINT32 Channel,UINT32 *Mode);
typedef BOOL (__stdcall *G39DDC_SET_DEMODULATOR_PARAM)(INT32 hDevice,UINT32 Channel,UINT32 Code,CONST VOID *Buffer,UINT32 BufferSize);
typedef BOOL (__stdcall *G39DDC_GET_DEMODULATOR_PARAM)(INT32 hDevice,UINT32 Channel,UINT32 Code,VOID *Buffer,UINT32 BufferSize);
typedef BOOL (__stdcall *G39DDC_GET_DEMODULATOR_STATE)(INT32 hDevice,UINT32 Channel,UINT32 Code,VOID *Buffer,UINT32 BufferSize);
typedef BOOL (__stdcall *G39DDC_SET_DRM_KEY)(INT32 hDevice,CONST CHAR *DRMKeyFileDirectory);
typedef BOOL (__stdcall *G39DDC_IS_DRM_UNLOCKED)(INT32 hDevice,BOOL *Unlocked);
typedef BOOL (__stdcall *G39DDC_GET_AUDIO_SAMPLE_RATE_COUNT)(INT32 hDevice,UINT32 *Count);
typedef BOOL (__stdcall *G39DDC_GET_AUDIO_SAMPLE_RATE)(INT32 hDevice,UINT32 Index,UINT32 *SampleRate);
typedef BOOL (__stdcall *G39DDC_START_AUDIO)(INT32 hDevice,UINT32 Channel,UINT32 SamplesPerBuffer);
typedef BOOL (__stdcall *G39DDC_STOP_AUDIO)(INT32 hDevice,UINT32 Channel);
typedef BOOL (__stdcall *G39DDC_SET_AUDIO)(INT32 hDevice,UINT32 Channel,UINT32 SampleRateIndex);
typedef BOOL (__stdcall *G39DDC_GET_AUDIO)(INT32 hDevice,UINT32 Channel,UINT32 *SampleRateIndex);
typedef BOOL (__stdcall *G39DDC_START_AUDIO_PLAYBACK)(INT32 hDevice,UINT32 Channel,UINT32 SamplesPerBuffer);
typedef BOOL (__stdcall *G39DDC_PAUSE_AUDIO_PLAYBACK)(INT32 hDevice,UINT32 Channel);
typedef BOOL (__stdcall *G39DDC_RESUME_AUDIO_PLAYBACK)(INT32 hDevice,UINT32 Channel);
typedef BOOL (__stdcall *G39DDC_SET_AUDIO_FILTER)(INT32 hDevice,UINT32 Channel,BOOL Enabled);
typedef BOOL (__stdcall *G39DDC_GET_AUDIO_FILTER)(INT32 hDevice,UINT32 Channel,BOOL *Enabled);
typedef BOOL (__stdcall *G39DDC_SET_AUDIO_FILTER_PARAMS)(INT32 hDevice,UINT32 Channel,UINT32 CutOffLow,UINT32 CutOffHigh,double Deemphasis);
typedef BOOL (__stdcall *G39DDC_GET_AUDIO_FILTER_PARAMS)(INT32 hDevice,UINT32 Channel,UINT32 *CutOffLow,UINT32 *CutOffHigh,double *Deemphasis);
typedef BOOL (__stdcall *G39DDC_SET_AUDIO_FILTER_LENGTH)(INT32 hDevice,UINT32 Channel,UINT32 Length);
typedef BOOL (__stdcall *G39DDC_GET_AUDIO_FILTER_LENGTH)(INT32 hDevice,UINT32 Channel,UINT32 *Length);
typedef BOOL (__stdcall *G39DDC_SET_AUDIO_GAIN)(INT32 hDevice,UINT32 Channel,double Gain);
typedef BOOL (__stdcall *G39DDC_GET_AUDIO_GAIN)(INT32 hDevice,UINT32 Channel,double *Gain);
typedef BOOL (__stdcall *G39DDC_SET_VOLUME)(INT32 hDevice,UINT32 Channel,BYTE Volume);
typedef BOOL (__stdcall *G39DDC_GET_VOLUME)(INT32 hDevice,UINT32 Channel,BYTE *Volume);
typedef BOOL (__stdcall *G39DDC_SET_MUTE)(INT32 hDevice,UINT32 Channel,BOOL Mute);
typedef BOOL (__stdcall *G39DDC_GET_MUTE)(INT32 hDevice,UINT32 Channel,BOOL *Mute);
typedef BOOL (__stdcall *G39DDC_START_SWEEPING)(INT32 hDevice,UINT64 BeginFrequency,UINT64 EndFrequency,UINT64 StartFrequency,WORD SettlingTime,BOOL Forward);
typedef BOOL (__stdcall *G39DDC_STOP_SWEEPING)(INT32 hDevice);
typedef BOOL (__stdcall *G39DDC_GET_SPECTRUM_COMPENSATION)(INT32 hDevice,UINT64 FrontEndFrequency,INT32 Shift,UINT32 Bandwidth,float *Buffer,UINT32 Count);
typedef BOOL (__stdcall *G39DDC_GET_IF_SPECTRUM_COMPENSATION)(INT32 hDevice,UINT64 FrontEndFrequency,float *Buffer,UINT32 Count);
typedef BOOL (__stdcall *G39DDC_SET_DAC)(INT32 hDevice,UINT32 DAC);
typedef BOOL (__stdcall *G39DDC_GET_DAC)(INT32 hDevice,UINT32 *DAC);
typedef BOOL (__stdcall *G39DDC_FLUSH_BUFFERS)(INT32 hDevice,UINT32 Channel,UINT32 Flags);
typedef BOOL (__stdcall *G39DDC_GET_TEMPERATURE)(INT32 hDevice,UINT32 *Temperature);
typedef BOOL (__stdcall *G39DDC_SET_INVERTED)(INT32 hDevice,BOOL Inverted);
typedef BOOL (__stdcall *G39DDC_GET_INVERTED)(INT32 hDevice,BOOL *Inverted);
typedef BOOL (__stdcall *G39DDC_SET_DDC2_NOISE_BLANKER)(INT32 hDevice,UINT32 Channel,BOOL Enabled);
typedef BOOL (__stdcall *G39DDC_GET_DDC2_NOISE_BLANKER)(INT32 hDevice,UINT32 Channel,BOOL *Enabled);
typedef BOOL (__stdcall *G39DDC_SET_DDC2_NOISE_BLANKER_THRESHOLD)(INT32 hDevice,UINT32 Channel,double Threshold);
typedef BOOL (__stdcall *G39DDC_GET_DDC2_NOISE_BLANKER_THRESHOLD)(INT32 hDevice,UINT32 Channel,double *Threshold);
typedef BOOL (__stdcall *G39DDC_GET_DDC2_NOISE_BLANKER_EXCESS_VALUE)(INT32 hDevice,UINT32 Channel,double *Value);
typedef BOOL (__stdcall *G39DDC_GET_DEVICE_STATE)(INT32 hDevice,UINT32 *State);

//SetCallbacks
typedef BOOL (__stdcall *G39DDC_SET_CALLBACKS)(INT32 hDevice,CONST G39DDC_CALLBACKS *Callbacks,DWORD_PTR UserData);


#endif


